// current page change
window.addEventListener("pageshow", parentfolderCheck, true);
// selecting a tab
window.addEventListener("select", parentfolderCheck, true);

/* Looks if there is a parent folder, otherwise disable the toolbar (greyed)
 */
function parentfolderCheck(event)
  {
    var toolbar = document.getElementById("parentfolder-button");
    var menu = document.getElementById("parentfolder-menu");
    
    if (parentfolder() == false)
      {
        toolbar.setAttribute("disabled", true);
        menu.setAttribute("disabled", true);
      }
    else
      {
        toolbar.setAttribute("disabled", false);
        menu.setAttribute("disabled", false);
      }
  }

/* Returns the parent of folder
 */
function parentfolder(src)
  {
    var url;
    
    if (src != null)
        url = src;
    else
        url = window._content.document.location.href;
    
    // the url has an ? , so first parent will be the file
    if (url.indexOf("?") > 0)
        url = url.substring(0, url.indexOf("?"))
    else if (!url.match(/^[^:]+:\/\/[^\/]*\/$/)) 
        // match the last part of URL and replace by nothing
        url = url.replace(/([^\/]*\/$)|([^\/]*$)/, '');
    else if (checkSub(url)) 
    {    // remove the subdomain
		url = "http://" + url.substring(url.indexOf('.')+1); }
    else
        url = false;
    
    return url;
  }

/* Change the current page
 */
function parentfolderGoTo(event)
  {
    var url, where=false;
    
    if (event != null)
      {
        // toolbar menu + middle click
        where = whereToOpenLink(event);
        if (event.target.label.indexOf("http://") == 0)
            // though the toolbar menu the url is the label
            url = event.target.label;
        else
            url = parentfolder();
      }
    else
        // Default action
        url = parentfolder();
    
    if (url != false && where != false && where != "current")
        // Open in new tab/window
        openUILinkIn(url, where);
    else if (url != false)
        // Open in current page
        window._content.document.location.href = url;
  }

/* Add ability to use icon with createMenuItem()
*/
function createMenuItemI( aParent, aIndex, aLabel, aImage )
{
    var menuitem = document.createElement( "menuitem" );
    menuitem.setAttribute( "label", aLabel );
    menuitem.setAttribute( "index", aIndex );
    menuitem.setAttribute( "image", aImage );
	menuitem.setAttribute( "class", "menuitem-iconic" ); 
    aParent.appendChild( menuitem );
}



/* Fill the toolbar menu
 */
function parentfolderFillMenu(event)
  {
    //deleteHistoryItems();
    while(event.target.hasChildNodes()){
        event.target.removeChild(event.target.firstChild);
    }

    //menu.removeAllItems();
    
    var url = parentfolder();
//    alert("="+url+"=");
    if (url != false)
      {
        for (var i = 0; url != false; i++)
          {
            createMenuItemI(event.target, i, url, url+"favicon.ico");
            url = parentfolder(url);
          }
      }
  }

/* Count instances of a char in a string
*/
function checkSub(string)
{
	var count = 0
	while ( string.indexOf('.')!=-1)
	{
		string = string.substring(string.indexOf('.')+1)
		count++;
	}
	if (count > 1 )
		return true;
	else
		return false;
}